clang 8.0.0

Public Member Functions | Static Public Member Functions | List of all members
clang::ento::GRBugReporter Class Reference

GRBugReporter is used for generating path-sensitive reports. More...

`#include "clang/StaticAnalyzer/Core/BugReporter/BugReporter.h"`

Inheritance diagram for clang::ento::GRBugReporter:
[legend]
Collaboration diagram for clang::ento::GRBugReporter:
[legend]

## Public Member Functions
| GRBugReporter (BugReporterData &d, ExprEngine &eng)
| ~GRBugReporter () override
ExplodedGraph & | getGraph ()
| getGraph - Get the exploded graph created by the analysis engine for the analyzed method or function. More...
ProgramStateManager & | getStateManager ()
| getStateManager - Return the state manager used by the analysis engine. More...
std::unique_ptr< DiagnosticForConsumerMapTy > | generatePathDiagnostics (ArrayRef< PathDiagnosticConsumer *> consumers, ArrayRef< BugReport *> &bugReports) override
| `bugReports` A set of bug reports within a single equivalence class More...
Public Member Functions inherited from clang::ento::BugReporter
| BugReporter (BugReporterData &d)
virtual | ~BugReporter ()
void | FlushReports ()
| Generate and flush diagnostics for all bug reports. More...
Kind | getKind () const
DiagnosticsEngine & | getDiagnostic ()
ArrayRef< PathDiagnosticConsumer * > | getPathDiagnosticConsumers ()
iterator | begin ()
iterator | end ()
EQClasses_iterator | EQClasses_begin ()
EQClasses_iterator | EQClasses_end ()
ASTContext & | getContext ()
SourceManager & | getSourceManager ()
AnalyzerOptions & | getAnalyzerOptions ()
void | Register (BugType *BT)
void | emitReport (std::unique_ptr< BugReport > R)
| Add the given report to the set of reports tracked by BugReporter. More...
void | EmitBasicReport (const Decl *DeclWithIssue, const CheckerBase *Checker, StringRef BugName, StringRef BugCategory, StringRef BugStr, PathDiagnosticLocation Loc, ArrayRef< SourceRange > Ranges=None)
void | EmitBasicReport (const Decl *DeclWithIssue, CheckName CheckName, StringRef BugName, StringRef BugCategory, StringRef BugStr, PathDiagnosticLocation Loc, ArrayRef< SourceRange > Ranges=None)

## Static Public Member Functions
static bool | classof (const BugReporter *R)
| classof - Used by isa<>, cast<>, and dyn_cast<>. More...

## Additional Inherited Members
Public Types inherited from clang::ento::BugReporter
enum | Kind { BaseBRKind, GRBugReporterKind }
using | iterator = BugTypesTy::iterator
| Iterator over the set of BugTypes tracked by the BugReporter. More...
using | EQClasses_iterator = llvm::FoldingSet< BugReportEquivClass >::iterator
| Iterator over the set of BugReports tracked by the BugReporter. More...
Protected Member Functions inherited from clang::ento::BugReporter
| BugReporter (BugReporterData &d, Kind k)

## Detailed Description

GRBugReporter is used for generating path-sensitive reports.

Definition at line 513 of file BugReporter.h.

## Constructor & Destructor Documentation

## ◆ GRBugReporter()

clang::ento::GRBugReporter::GRBugReporter | ( | BugReporterData & | d,
|  | ExprEngine & | eng
| ) |  |
| inline

Definition at line 517 of file BugReporter.h.

## ◆ ~GRBugReporter()

GRBugReporter::~GRBugReporter | ( |  | ) |
| override default

Referenced by clang::ento::BugReport::getLocation().

## Member Function Documentation

## ◆ classof()

static bool clang::ento::GRBugReporter::classof | ( | const BugReporter * | R | ) |
| inline static

classof - Used by isa<>, cast<>, and dyn_cast<>.

Definition at line 540 of file BugReporter.h.

References clang::ento::BugReporter::getKind().

## ◆ generatePathDiagnostics()

std::unique_ptr<DiagnosticForConsumerMapTy> clang::ento::GRBugReporter::generatePathDiagnostics | ( | ArrayRef< PathDiagnosticConsumer *> | consumers,
|  | ArrayRef< BugReport *> & | bugReports
| ) |  |
| override virtual

`bugReports` A set of bug reports within a single equivalence class

Returns
  A mapping from consumers to the corresponding diagnostics. Iterates through the bug reports within a single equivalence class, stops at a first non-invalidated report.

Reimplemented from clang::ento::BugReporter.

Referenced by CompactMacroExpandedPieces().

## ◆ getGraph()

ExplodedGraph & GRBugReporter::getGraph | ( |  | ) |

getGraph - Get the exploded graph created by the analysis engine for the analyzed method or function.

Definition at line 2234 of file BugReporter.cpp.

Referenced by clang::ento::BugReporterContext::getGraph().

## ◆ getStateManager()

ProgramStateManager & GRBugReporter::getStateManager | ( |  | ) |

getStateManager - Return the state manager used by the analysis engine.

Definition at line 2237 of file BugReporter.cpp.

Referenced by clang::ento::BugReporterContext::getStateManager().

The documentation for this class was generated from the following files:

- include/clang/StaticAnalyzer/Core/BugReporter/BugReporter.h
- lib/StaticAnalyzer/Core/BugReporter.cpp